// Copyright(c) 2oo1 by Darkyoda and MENTAL VORTEX

// 
// Description:
// 
// Black and White HD File Loader
// 
//
// 
// 


//
// Comments :
//
// 19.April
// DY : Created this File
//
//
//



// Includes
#include			"main.h"



//
// Functions
//

//
// Shutdown Archive
//
void	ExtractHD( void )
{
	char		*data;
	int			size;

	if(!LoadDialog( "ModelView: ExtractHD", "HelpDude (*.HD)\0*.HD\0All Files(*.*)\0*.*\0\0" ))
		return;

	//
	// Safe Read File
	//
	assert( gpFilename );

	printf( "\nLoading Archive %s ...\n\n", gpFilename );

	FILE		*fp;
	
	fp = fopen( gpFilename, "rb" );

	if( !fp )
	{
		printf( "ERROR : Unable to Open Specified File %s\n", gpFilename );
		return;
	}

	fseek( fp, 0, SEEK_END );
	size = ftell( fp );
	fseek( fp, 0, SEEK_SET );

	assert( size );

	data = new char[size];

	assert( data );	
	
	fread( data, size, 1, fp );
	
	fclose( fp );



	//
	// Check
	//
	if( (data[0] != 'L') &&
		(data[1] != 'i') &&
		(data[2] != 'O') &&
		(data[3] != 'n') &&
		(data[4] != 'H') &&
		(data[5] != 'e') &&
		(data[6] != 'A') &&
		(data[7] != 'd'))
	{
		printf( "ERROR : Invalid Header Id, should be \"LiOnHeAd\" is \"%c%c%c%c%c%c%c%c\"\n", 
				data[0], data[1], data[2], data[3], data[4], data[5], data[6], data[7] );

		delete[]data;
		return;
	}

	HD_Header	*pHeader = (HD_Header*)((LH_BlockHeader*)(data+8)+1);
	char		*pModel	 = (char*)(pHeader+1) + (pHeader->mnNames)*128;

	char		*pName   = pHeader->mModelName+strlen(pHeader->mModelName);


	//
	// Kill Pathname
	//
	while( pName > pHeader->mModelName )
	{
		--pName;	
		if( *pName == '\\' || *pName == '/' )
			break;
	}

	++pName;

	fp = fopen( pName, "wb" );

	assert( fp );

	fwrite( (DWORD*)pModel+2, *((DWORD*)pModel+1), 1, fp );

	fclose( fp );
	

	delete[]data;
}
