// Copyright(c) 2oo1 by Mental Vortex
#ifndef _TGA_H_
#define _TGA_H_
// 
// Description:
// 
// Truvision Targa Format
// 
// 
// 
// 




// Includes



//
// Structures
//
#pragma pack(1)
struct TGA_Header
{
	byte	mIDLength;
	byte    mColorMapType;
	byte	mImageType;

	// Color Map Specification
	short	mColorMapFirstEntryIndex;
	short	mColorMapLength;
	byte	mColorMapEntrySize;

	// ImageSpecification
	short	mXOrigin;
	short	mYOrigin;
	short	mXSize;
	short	mYSize;
	byte	mPixelDepth;
	byte	mImageDescriptor;		// 0-3 Alpha Channel Bits
									// 5+4 Origin Alignment
									// 6+7 Must be zero
};
#pragma pack()


//
// Functions
//

//
// Writes a TGA directly from L3D skinbuffer
//
void		TGA_SaveRGBA4444		( void *inData, char *inName, int inNBlocks );
void		TGA_LoadRGBA			( byte *inData, char *inName );

#endif //_TGA_H_