// Copyright(c) 2oo1 by Darkyoda and MENTAL VORTEX

// 
// Description:
// 
// Black and White ANM File Loader
// 
//
// 
// 


//
// Comments :
//
// 15.April
// DY : Created this File
//
//
//




// Includes
#include			"main.h"



//
// Globals
//
int					gANMType					= 0;
char				*gANMListBuffer				= NULL;
ANM_BaseHeader		**gANMListHeaders			= NULL;
char				**gANMListData				= NULL;
int					gANMListPlaying				= 0;

char				gANMStringList[MAX_COUNT_3D_ANIMS+1][40] = 
{
    "ANM_BAT_ERATICGLIDE",
    "ANM_BAT_FLAP",
    "ANM_BAT_GLIDE",
    "ANM_CROW_FLAP",
    "ANM_CROW_GLIDE",
    "ANM_CROW_LANDING",
    "ANM_CROW_SIT",
    "ANM_CROW_TAKEOFF",
    "ANM_DOVE_FLAP",
    "ANM_DOVE_GLIDE",
    "ANM_DOVE_LANDING",
    "ANM_DOVE_SIT",
    "ANM_DOVE_TAKEOFF",
    "ANM_PIGEON_FLAP",
    "ANM_PIGEON_GLIDE",
    "ANM_PIGEON_LANDING",
    "ANM_PIGEON_SIT",
    "ANM_PIGEON_TAKEOFF",
    "ANM_SEAGULL_FLAP",
    "ANM_SEAGULL_GENTLEFLAP",
    "ANM_SEAGULL_GLIDE",
    "ANM_SEAGULL_LANDING",
    "ANM_SEAGULL_TAKEOFF",
    "ANM_SPELL_DOVE_FLAP",
    "ANM_SPELL_DOVE_GLIDE",
    "ANM_SWALLOW_CALMGLIDE",
    "ANM_SWALLOW_ERATICGLIDE",
    "ANM_SWALLOW_FLAP",
    "ANM_A_COW_DEAD",
    "ANM_A_COW_DEAD_ON_LHS",
    "ANM_A_COW_DEAD_ON_RHS",
    "ANM_A_COW_DIE",
    "ANM_A_COW_DOWNED_ON_LHS",
    "ANM_A_COW_DOWNED_ON_RHS",
    "ANM_A_COW_DROWNING",
    "ANM_A_COW_EAT_1",
    "ANM_A_COW_EAT_2",
    "ANM_A_COW_GOTO_EAT",
    "ANM_A_COW_IN_HAND",
    "ANM_A_COW_LANDED_LEFT_SIDE",
    "ANM_A_COW_LANDED_RIGHT_SIDE",
    "ANM_A_COW_RUN",
    "ANM_A_COW_STAND",
    "ANM_A_COW_THROWN",
    "ANM_A_COW_UPFROM_EAT",
    "ANM_A_COW_WALK",
    "ANM_A_HORSE_DEADLHS",
    "ANM_A_HORSE_DEADRHS",
    "ANM_A_HORSE_EAT1",
    "ANM_A_HORSE_EAT2",
    "ANM_A_HORSE_FALL_DEADLHS",
    "ANM_A_HORSE_FALL_DEADRHS",
    "ANM_A_HORSE_GOTO_EAT",
    "ANM_A_HORSE_IN_HAND",
    "ANM_A_HORSE_LAND_GET_UPLHS",
    "ANM_A_HORSE_LAND_GET_UPRHS",
    "ANM_A_HORSE_RUN",
    "ANM_A_HORSE_STAND",
    "ANM_A_HORSE_THROWN",
    "ANM_A_HORSE_TROT",
    "ANM_A_HORSE_UP_FROM_EAT",
    "ANM_A_HORSE_WALK",
    "ANM_A_LEOPARD_DEAD",
    "ANM_A_LEOPARD_DEAD_ON_LEFT",
    "ANM_A_LEOPARD_DEAD_ON_RIGHT",
    "ANM_A_LEOPARD_DIE",
    "ANM_A_LEOPARD_EAT",
    "ANM_A_LEOPARD_GET_UP_FROM_LEFT",
    "ANM_A_LEOPARD_GET_UP_FROM_RIGHT",
    "ANM_A_LEOPARD_GOTO_EAT",
    "ANM_A_LEOPARD_GOTO_SIT",
    "ANM_A_LEOPARD_GOTO_SLEEP",
    "ANM_A_LEOPARD_IN_HAND",
    "ANM_A_LEOPARD_POUNCE",
    "ANM_A_LEOPARD_POUNCE_HI",
    "ANM_A_LEOPARD_POUNCE_LO",
    "ANM_A_LEOPARD_PROWL",
    "ANM_A_LEOPARD_RUN",
    "ANM_A_LEOPARD_SIT",
    "ANM_A_LEOPARD_SLEEP",
    "ANM_A_LEOPARD_STAND",
    "ANM_A_LEOPARD_THROWN",
    "ANM_A_LEOPARD_UPFROM_EAT",
    "ANM_A_LEOPARD_UPFROM_SIT",
    "ANM_A_LEOPARD_UPFROM_SLEEP",
    "ANM_A_LEOPARD_WALK",
    "ANM_A_LION_DEAD",
    "ANM_A_LION_DEAD_ON_LEFT",
    "ANM_A_LION_DEAD_ON_RIGHT",
    "ANM_A_LION_DIE",
    "ANM_A_LION_DOWNED_ON_LHS",
    "ANM_A_LION_DOWNED_ON_RHS",
    "ANM_A_LION_EAT",
    "ANM_A_LION_GET_UP_FROM_LEFT",
    "ANM_A_LION_GET_UP_FROM_RIGHT",
    "ANM_A_LION_GOTO_EAT",
    "ANM_A_LION_GOTO_SIT",
    "ANM_A_LION_GOTO_SLEEP",
    "ANM_A_LION_IN_HAND",
    "ANM_A_LION_POUNCE",
    "ANM_A_LION_POUNCE_HI",
    "ANM_A_LION_POUNCE_LO",
    "ANM_A_LION_PROWL",
    "ANM_A_LION_RUN",
    "ANM_A_LION_SIT",
    "ANM_A_LION_SLEEP",
    "ANM_A_LION_STAND",
    "ANM_A_LION_THROWN",
    "ANM_A_LION_TURN_LEFT_90_DEGREES",
    "ANM_A_LION_TURN_RIGHT_90_DEGREES",
    "ANM_A_LION_UPFROM_EAT",
    "ANM_A_LION_UPFROM_SIT",
    "ANM_A_LION_UPFROM_SLEEP",
    "ANM_A_LION_WALK",
    "ANM_A_PIG_DEADLHS",
    "ANM_A_PIG_DEADRHS",
    "ANM_A_PIG_EAT1",
    "ANM_A_PIG_EAT2",
    "ANM_A_PIG_FALL_DEADLHS",
    "ANM_A_PIG_FALL_DEADRHS",
    "ANM_A_PIG_GOTO_EAT",
    "ANM_A_PIG_IN_HAND",
    "ANM_A_PIG_LAND_GET_UPLHS",
    "ANM_A_PIG_LAND_GET_UPRHS",
    "ANM_A_PIG_OUT_OF_EAT",
    "ANM_A_PIG_RUN",
    "ANM_A_PIG_STAND",
    "ANM_A_PIG_THROWN",
    "ANM_A_PIG_WALK",
    "ANM_SHARK_BONED_SWIM",
    "ANM_A_SHEEP_DEAD_LHS",
    "ANM_A_SHEEP_DEAD_RHS",
    "ANM_A_SHEEP_EAT1",
    "ANM_A_SHEEP_EAT2",
    "ANM_A_SHEEP_FALL_DEADLHS",
    "ANM_A_SHEEP_FALL_DEADRHS",
    "ANM_A_SHEEP_GOTO_EAT",
    "ANM_A_SHEEP_IN_HAND",
    "ANM_A_SHEEP_LANDED_GETUPLHS",
    "ANM_A_SHEEP_LANDED_GETUPRHS",
    "ANM_A_SHEEP_OUT_OF_EAT",
    "ANM_A_SHEEP_RUN",
    "ANM_A_SHEEP_STAND",
    "ANM_A_SHEEP_THROWN",
    "ANM_A_SHEEP_TROT",
    "ANM_A_SHEEP_WALK",
    "ANM_A_TIGER_DEAD",
    "ANM_A_TIGER_DEAD_ON_LEFT",
    "ANM_A_TIGER_DEAD_ON_RIGHT",
    "ANM_A_TIGER_DIE",
    "ANM_A_TIGER_EAT",
    "ANM_A_TIGER_GET_UP_FROM_LEFT",
    "ANM_A_TIGER_GET_UP_FROM_RIGHT",
    "ANM_A_TIGER_GOTO_EAT",
    "ANM_A_TIGER_GOTO_SIT",
    "ANM_A_TIGER_GOTO_SLEEP",
    "ANM_A_TIGER_IN_HAND",
    "ANM_A_TIGER_POUNCE",
    "ANM_A_TIGER_POUNCE_HI",
    "ANM_A_TIGER_POUNCE_LO",
    "ANM_A_TIGER_PROWL",
    "ANM_A_TIGER_RUN",
    "ANM_A_TIGER_SIT",
    "ANM_A_TIGER_SLEEP",
    "ANM_A_TIGER_STAND",
    "ANM_A_TIGER_THROWN",
    "ANM_A_TIGER_UPFROM_EAT",
    "ANM_A_TIGER_UPFROM_SIT",
    "ANM_A_TIGER_UPFROM_SLEEP",
    "ANM_A_TIGER_WALK",
    "ANM_A_TORTOISE_DEAD",
    "ANM_A_TORTOISE_STAND",
    "ANM_A_TORTOISE_WALK",
    "ANM_A_WOLF_DIE",
    "ANM_A_WOLF_EAT",
    "ANM_A_WOLF_GOTO_EAT",
    "ANM_A_WOLF_GOTO_SIT",
    "ANM_A_WOLF_GOTO_SLEEP",
    "ANM_A_WOLF_HOWL",
    "ANM_A_WOLF_POUNCE",
    "ANM_A_WOLF_PROWL",
    "ANM_A_WOLF_RUN",
    "ANM_A_WOLF_SIT",
    "ANM_A_WOLF_SLEEP",
    "ANM_A_WOLF_STAND",
    "ANM_A_WOLF_UPFROM_EAT",
    "ANM_A_WOLF_UPFROM_SIT",
    "ANM_A_WOLF_UPFROM_SLEEP",
    "ANM_A_WOLF_WALK",
    "ANM_MINE_ENTRANCE",
    "ANM_PLAYER_ICON01_PLINTH",
    "ANM_NORS_GATE",
    "ANM_PHONEBOX",
    "ANM_PIPER_CAVE_CLOSING",
    "ANM_PIPER_CAVE_OPENING",
    "ANM_GATE_TOTEM_PLINTHE",
    "ANM_PIED_PIPER_DANCE_STAND",
    "ANM_PIED_PIPER_DANCE_STAND_SPIN",
    "ANM_PIED_PIPER_DANCE_WALK",
    "ANM_PIED_PIPER_DANCE_WALK_SPIN",
    "ANM_PIED_PIPER_SUMMON",
    "ANM_PIED_PIPER_WALK",
    "ANM_P_AFRICAN_DRUMMER",
    "ANM_P_AMBIENT1",
    "ANM_P_AMBIENT2",
    "ANM_P_ARSONIST",
    "ANM_P_ATTACKED_BY_LION",
    "ANM_P_ATTRACT_YOUR_ATTENTION",
    "ANM_P_AVOID_OBJECT_DIVE",
    "ANM_P_AVOID_OBJECT_DODGE",
    "ANM_P_BECKON",
    "ANM_P_BLOW_RASPBERRY",
    "ANM_P_CARRYING_BAG",
    "ANM_P_CARRYING_POT",
    "ANM_P_CARRYING_STICKS",
    "ANM_P_CARRY_AXE",
    "ANM_P_CARRY_OBJECT_RUN",
    "ANM_P_CHOPPING_TREE",
    "ANM_P_CLAP_1",
    "ANM_P_CLAP_2",
    "ANM_P_CLAP_3",
    "ANM_P_CLAP_4",
    "ANM_P_CONDUCT_MEETING",
    "ANM_P_COUPLE_KISS_MAN",
    "ANM_P_COUPLE_KISS_WOMAN",
    "ANM_P_CRAWL_INJURED",
    "ANM_P_CRAWL_INJURED_INTO",
    "ANM_P_CROWD_IMPRESSED_1",
    "ANM_P_CROWD_IMPRESSED_2",
    "ANM_P_CROWD_LOST",
    "ANM_P_CROWD_LOST_2",
    "ANM_P_CROWD_MEXICAN_WAVE",
    "ANM_P_CROWD_UNIMPRESSED_1",
    "ANM_P_CROWD_UNIMPRESSED_2",
    "ANM_P_CROWD_WON",
    "ANM_P_CROWD_WON_2",
    "ANM_P_DANCE_PISS_TAKE_",
    "ANM_P_DANCE_STAND",
    "ANM_P_DANCE_TOGETHER_ARMLINK",
    "ANM_P_DANCE_TOGETHER_CIRCLING",
    "ANM_P_DANCE_TOGETHER_CIRCLING_PARTNER",
    "ANM_P_DANCE_X",
    "ANM_P_DANCE_X_PARTNER",
    "ANM_P_DEAD1",
    "ANM_P_DEAD1_GOTO_HEAVEN",
    "ANM_P_DEAD1_GOTO_HELL",
    "ANM_P_DEAD2",
    "ANM_P_DEAD2_GOTO_HEAVEN",
    "ANM_P_DEAD2_GOTO_HELL",
    "ANM_P_DEAD_DROWNED",
    "ANM_P_DEAD_IN_HAND",
    "ANM_P_DRIBBLE_BALL",
    "ANM_P_DROWNING",
    "ANM_P_DYING",
    "ANM_P_EAT",
    "ANM_P_FAKE_FOUL_FALL",
    "ANM_P_FARMER",
    "ANM_P_FARMER_HARVESTING",
    "ANM_P_FARMER_SHOO_SHEEP",
    "ANM_P_FARMER_SOWING_SEEDS",
    "ANM_P_FARMER_STOKE_SHEEP",
    "ANM_P_FARMER_TURNING_SOIL",
    "ANM_P_FISHERMAN",
    "ANM_P_FRIGHT_DUCK",
    "ANM_P_FRIGHT_JUMP",
    "ANM_P_F_DANCE_A",
    "ANM_P_F_DANCE_B",
    "ANM_P_F_DANCE_C",
    "ANM_P_GIVE_BIRTH",
    "ANM_P_GOALKEEPER",
    "ANM_P_GOALKEEPER_2",
    "ANM_P_GOALKEEPER_3",
    "ANM_P_GOSSIP_MAN",
    "ANM_P_GOSSIP_WOMAN_1",
    "ANM_P_GOSSIP_WOMAN_2",
    "ANM_P_GOSSIP_WOMAN_3",
    "ANM_P_HAMMERING",
    "ANM_P_HELP_SOMEONE_HELPEE",
    "ANM_P_HELP_SOMEONE_HELPER",
    "ANM_P_HUG",
    "ANM_P_INSPECT_OBJECT_1",
    "ANM_P_INSPECT_OBJECT_2",
    "ANM_P_INSPECT_OBJECT_3",
    "ANM_P_INTO_DEAD_DROWNED",
    "ANM_P_INTO_HAMMERING",
    "ANM_P_INTO_MOURNING",
    "ANM_P_INTO_POINTING",
    "ANM_P_INTO_PRAY",
    "ANM_P_INTO_PULL_OBJECT",
    "ANM_P_INTO_PUSH_OBJECT",
    "ANM_P_INTO_RUN_MAN",
    "ANM_P_INTO_RUN_WOMAN",
    "ANM_P_INTO_SAW_WOOD",
    "ANM_P_INTO_SLEDGEHAMMER",
    "ANM_P_INTO_SLEEP",
    "ANM_P_INTO_SPRINT_MAN",
    "ANM_P_INTO_SPRINT_WOMAN",
    "ANM_P_INTO_WALK_MAN",
    "ANM_P_INTO_WALK_WOMAN",
    "ANM_P_JUMP_A",
    "ANM_P_JUMP_AT_HAND",
    "ANM_P_JUMP_AT_HAND_2",
    "ANM_P_KICK_BALL",
    "ANM_P_KICK_BALL_PASS",
    "ANM_P_KICK_BALL_PASS_PT1",
    "ANM_P_KICK_BALL_PASS_PT2",
    "ANM_P_LANDED",
    "ANM_P_LANDED_FROM_BACK",
    "ANM_P_LANDED_FROM_FEET",
    "ANM_P_LANDED_FROM_FEET_CARRY_OBJECT",
    "ANM_P_LOOKING_FOR_SOMETHING",
    "ANM_P_LOOK_AT_HAND",
    "ANM_P_LOVING_TOUCH",
    "ANM_P_MOURNING",
    "ANM_P_M_DANCE_A",
    "ANM_P_M_DANCE_B",
    "ANM_P_M_DANCE_C",
    "ANM_P_ON_FIRE_DIE",
    "ANM_P_ON_FIRE_DOUSED",
    "ANM_P_ON_FIRE_RUN",
    "ANM_P_OUT_OF_HAMMERING",
    "ANM_P_OUT_OF_MOURNING",
    "ANM_P_OUT_OF_POINTING",
    "ANM_P_OUT_OF_PRAY",
    "ANM_P_OUT_OF_PULL_OBJECT",
    "ANM_P_OUT_OF_PUSH_OBJECT",
    "ANM_P_OUT_OF_RUN_MAN",
    "ANM_P_OUT_OF_RUN_WOMAN",
    "ANM_P_OUT_OF_SAW_WOOD",
    "ANM_P_OUT_OF_SLEDGEHAMMER",
    "ANM_P_OUT_OF_SLEEP",
    "ANM_P_OUT_OF_WALK_WOMAN",
    "ANM_P_OVERWORKED1",
    "ANM_P_OVERWORKED2",
    "ANM_P_PANIC_MAN",
    "ANM_P_PANIC_WOMAN",
    "ANM_P_PICKUP_BALL_PT1",
    "ANM_P_PICKUP_BALL_PT2",
    "ANM_P_PICK_UP_BAG",
    "ANM_P_PICK_UP_POT_ON_HEAD",
    "ANM_P_PICK_UP_STICKS",
    "ANM_P_PLAY_ACCORDIAN",
    "ANM_P_POISONED",
    "ANM_P_PRAY",
    "ANM_P_PROD_CAMPFIRE",
    "ANM_P_PULL_OBJECT",
    "ANM_P_PUSH_OBJECT",
    "ANM_P_PUT_DOWN_BAG",
    "ANM_P_PUT_DOWN_STICKS",
    "ANM_P_PUT_OUT_FIRE",
    "ANM_P_PUZZLED",
    "ANM_P_RUN_MAN",
    "ANM_P_RUN_WITH_BALL",
    "ANM_P_RUN_WOMAN",
    "ANM_P_SAW_WOOD",
    "ANM_P_SCARED_STIFF",
    "ANM_P_SCARED_STIFF_2",
    "ANM_P_SCORE_GOAL",
    "ANM_P_SCRIPT1",
    "ANM_P_SCRUBBS",
    "ANM_P_SCULPTOR",
    "ANM_P_SHAKE_FIST_FEMALE",
    "ANM_P_SHOOT_AT_GOAL",
    "ANM_P_SHOOT_AT_GOAL_2",
    "ANM_P_SHOOT_AT_GOAL_PT_1",
    "ANM_P_SHOOT_AT_GOAL_PT_2",
    "ANM_P_SHRUG_SHOULDERS",
    "ANM_P_SITTING_DOWN1_INTO",
    "ANM_P_SITTING_DOWN1_OUT_OF",
    "ANM_P_SITTING_DOWN1_SITTING",
    "ANM_P_SITTING_DOWN2_INTO",
    "ANM_P_SITTING_DOWN2_OUT_OF",
    "ANM_P_SITTING_DOWN2_SITTING",
    "ANM_P_SITTING_DOWN_DANCE_SAILING1",
    "ANM_P_SITTING_DOWN_DANCE_SAILING2",
    "ANM_P_SITTING_DOWN_DANCE_SAILING3",
    "ANM_P_SITTING_DOWN_MALE1",
    "ANM_P_SITTING_DOWN_MALE2",
    "ANM_P_SITTING_SWINGING_LEGS",
    "ANM_P_SKIP02",
    "ANM_P_SLEDGEHAMMER",
    "ANM_P_SLEEP",
    "ANM_P_SLEEPING",
    "ANM_P_SPRINT_RUN_MAN",
    "ANM_P_SPRINT_RUN_WOMAN",
    "ANM_P_STAND",
    "ANM_P_STAND_DESPAIR_1",
    "ANM_P_STAND_DESPAIR_2",
    "ANM_P_STAND_DESPAIR_3",
    "ANM_P_STIR_POT01",
    "ANM_P_SWIM2",
    "ANM_P_TALK1_FEMALE",
    "ANM_P_TALK1_MALE",
    "ANM_P_TALK2_FEMALE",
    "ANM_P_TALK2_MALE",
    "ANM_P_TALKING_AND_POINTING",
    "ANM_P_TALK_TO_NEIGHBOUR",
    "ANM_P_THANK_YOU",
    "ANM_P_THANK_YOU_FEMALE",
    "ANM_P_THROWN",
    "ANM_P_THROWN_DEAD",
    "ANM_P_THROWN_VORTEX",
    "ANM_P_THROW_BALL_PT_1",
    "ANM_P_THROW_BALL_PT_2",
    "ANM_P_THROW_ROCK",
    "ANM_P_THROW_WATER",
    "ANM_P_TITANIC",
    "ANM_P_TURN_180",
    "ANM_P_TURN_90_LEFT",
    "ANM_P_TURN_90_RIGHT",
    "ANM_P_TURN_ON_THE_SPOT_LEFT",
    "ANM_P_TURN_ON_THE_SPOT_RIGHT",
    "ANM_P_WAITING_FOR_BALL",
    "ANM_P_WAITING_FOR_BALL_2",
    "ANM_P_WAITING_FOR_KICK_OFF",
    "ANM_P_WAITING_FOR_KICK_OFF_2",
    "ANM_P_WAITING_FOR_KICK_OFF_3",
    "ANM_P_WAITING_FOR_KICK_OFF_4",
    "ANM_P_WAITING_IMPATEINTLY",
    "ANM_P_WALK_BECKON02",
    "ANM_P_WALK_DESPAIR_AWAY_1",
    "ANM_P_WALK_DESPAIR_AWAY_2",
    "ANM_P_WALK_DESPAIR_AWAY_3",
    "ANM_P_WALK_DESPAIR_TO_1",
    "ANM_P_WALK_DESPAIR_TO_2",
    "ANM_P_WALK_DESPAIR_TO_3",
    "ANM_P_WALK_INJURED",
    "ANM_P_WALK_MAN",
    "ANM_P_WALK_POINT",
    "ANM_P_WALK_TIRED_EYES",
    "ANM_P_WALK_TO_STAND_WOMAN",
    "ANM_P_WALK_WOMAN",
    "ANM_P_WELL_DONE__FEMALE",
    "ANM_P_WHITTLING_AT_STICK",
    "ANM_P_YANKED_UNDERGROUND",
    "ANM_P_YANKED_UNDERGROUND2",
    "ANM_P_YANKED_UNDERGROUND3",
    "ANM_P_YAWN",
    "ANM_P_YAWN2",
    "ANM_S_PRIEST_SUCK_LIFE_FORCE",
    "ANM_A_WORM",
    "MAX_COUNT_3D_ANIMS"
};

//
// Functions
// 





//
// Shutdown ANM List File
// 
void ShutANMList( void )
{
	gpLoadFromANM->disable( );
	gpLoadFromANM2->disable( );

	if( gANMListBuffer )
	{
		delete[] gANMListBuffer;
		gANMListBuffer = NULL;
	}

	if( gANMListHeaders )
	{
		delete[] gANMListHeaders;
		gANMListHeaders = NULL;
	}

	if( gANMListData )
	{
		delete[] gANMListData;
		gANMListData = NULL;
	}
}

//
//
//
void LoadLHANM( int inSize )
{
	//
	// Setup Pointers
	//
	LH_BlockHeader		*pBlock = (LH_BlockHeader *)(gANMListBuffer+8); // skip LiOnHeAd

	gANMListHeaders = (ANM_BaseHeader **)	new DWORD[MAX_COUNT_3D_ANIMS];
	gANMListData	= (char **)				new DWORD[MAX_COUNT_3D_ANIMS];
	

	//
	// Read Blocks
	//
	while( (char *)pBlock < gANMListBuffer+inSize )
	{	

		if( !strncmp( pBlock->mnBlockName, "Julien", 6 ) )
		{
			int		num;

			sscanf( pBlock->mnBlockName, "Julien%i", &num );

			gANMListData[num] = (char *)(pBlock+1);

			//
			// Add to List
			//			
			gpLoadFromANM->add_item( num, gANMStringList[num] );
		}
		else
		if( !strcmp( pBlock->mnBlockName, "Body" ) )
		{
			LHANM_Body		*pBody = (LHANM_Body *)(pBlock+1);

			assert( pBody->mnAnims == MAX_COUNT_3D_ANIMS );

			assert( pBody->mnID == 'CJKM' ); // Hello Jean Claude :)

			int		header;
			for( header=0 ; header<MAX_COUNT_3D_ANIMS ; ++header )
			{
				gANMListHeaders[header] = (ANM_BaseHeader*)((char *)(pBlock+1)+*((DWORD *)(pBody+1)+header*2));

				printf( "%s\n", gANMListHeaders[header]->mAnimName );
			}
		}
		else
		{
			printf( "UNKNOWN %s Block\n", pBlock->mnBlockName );
			assert( 0 );
		}

		pBlock  = (LH_BlockHeader *)((char*)pBlock+pBlock->mnBlockSize+36);
	}

	gpLoadFromANM->enable( );
	gpLoadFromANM2->set_int_limits( 0, MAX_COUNT_3D_ANIMS-1 );
	gpLoadFromANM2->enable( );	
}



//
// Loads an Animation file, if it's a Lionhead File read it too
//
void LoadANM( void )
{
	if(!LoadDialog( "ModelView: LoadAnimation", "Animation(*.ANM)\0*.ANM\0All Files(*.*)\0*.*\0\0" ))
		return;

	ShutANM( );
	gANMType = 0;

	assert( gpModels[0].mLoaded );


	//
	// Safe Read File
	//
	assert( gpFilename );

	printf( "\nLoading Animation %s ...\n\n", gpFilename );

	FILE		*fp;
	DWORD		size;
	
	fp = fopen( gpFilename, "rb" );

	if( !fp )
	{
		printf( "ERROR : Unable to Open Specified File %s\n", gpFilename );
		ShutANM( );
		return;
	}

	fseek( fp, 0, SEEK_END );
	size = ftell( fp );
	fseek( fp, 0, SEEK_SET );

	assert( size );
	assert( !gpANMBuffer );

	gpANMBuffer = new char[size];

	assert( gpANMBuffer );	
	
	fread( gpANMBuffer, size, 1, fp );
	
	fclose( fp );


	//
	// Check Header
	//
	if( (gpANMBuffer[0] == 'L') &&
		(gpANMBuffer[1] == 'i') &&
		(gpANMBuffer[2] == 'O') &&
		(gpANMBuffer[3] == 'n') &&
		(gpANMBuffer[4] == 'H') &&
		(gpANMBuffer[5] == 'e') &&
		(gpANMBuffer[6] == 'A') &&
		(gpANMBuffer[7] == 'd'))
	{
		ShutANMList( );
		gANMListBuffer	= gpANMBuffer;
		gpANMBuffer		= NULL;
		LoadLHANM( size );
		return;
	}

	
	//
	// Setup Pointers
	//
	ANM_BaseHeader*		pHeader = (ANM_BaseHeader*) gpANMBuffer;
	ANM_Frame*			pFrame  = (ANM_Frame*)	( gpANMBuffer+		/// uhhhhhhhh yeaaaaah
									*(DWORD*)	( gpANMBuffer+		// this thing looks nasty :)
									*(DWORD*)	( gpANMBuffer+		// but its simple
									*(DWORD*)	( gpANMBuffer + pHeader->mpFrames ) ) ) );

	//
	// Allocating
	//
	if( pHeader->mnFrames == 1 )
		gppANMFrames = (ANM_Frame**) new DWORD[2];
	else
		gppANMFrames = (ANM_Frame**) new DWORD[pHeader->mnFrames];

	assert( gppANMFrames );


	//
	// Debug Printing
	//
	printf( "Animation Name : \"%s\"\nNumber of Frames : %i\nNumber of Bones : %i\n", pHeader->mAnimName, pHeader->mnFrames, pFrame->mnBones );


	//
	// And Error Checking
	//
	if( pFrame->mnBones != gpModels[0].mpMeshes->mnBones )
	{
		printf( "ERROR : Wrong Number of Bones in ANM : %i - %i\n", pFrame->mnBones, gpModels[0].mpMeshes->mnBones );
		ShutANM( );
		return;
	}


	



	DWORD		frame;
	for( frame=0 ; frame<pHeader->mnFrames ; ++frame )
	{
		gppANMFrames[frame] = (ANM_Frame*)	( gpANMBuffer +	 // i luv pointer operations :)
								*(DWORD*)	( gpANMBuffer +	
								*(DWORD*)	( gpANMBuffer +	
							(	(DWORD*)	( gpANMBuffer + pHeader->mpFrames ) ) [frame] ) ) );

		gppANMFrames[frame]->mpBones = (ANM_Bone*) (gpANMBuffer + (DWORD) gppANMFrames[frame]->mpBones);
		
	}

	if( pHeader->mnFrames == 1 )
	{
		gppANMFrames[1] = gppANMFrames[0];
		gpAnimTime->set_float_limits( 0.0f, 0.0f );
	}
	else
		gpAnimTime->set_float_limits( 0.0f, pHeader->mnFrames-2 );

	gpAnimTime->enable( );
	gpAnimTime->set_float_val( 0.0f );
	gpAnimPlay->enable( );
}



//
// Shutdown ANM File
// 
void ShutANM( void )
{
	if( gpANMBuffer )
	{
		if( gANMType == 0 ) delete[] gpANMBuffer;
		gpANMBuffer = NULL;
	}

	if( gppANMFrames )
	{
		if( gANMType == 0 ) delete[] gppANMFrames;
		gppANMFrames = NULL;
	}

	gpAnimTime->disable( );
	gpAnimPlay->disable( );	
}



//
// reads an ANM from Lionhead file if loaded
//
void ANMfromLH( int inIndex )
{
	gANMListPlaying = inIndex;

	ShutANM( );
	gANMType = 1;



	//
	// Setup Pointers
	//
	ANM_BaseHeader*		pHeader = (ANM_BaseHeader*) gANMListHeaders[inIndex];
	
	char *pANMBuffer = gANMListData[inIndex] - sizeof(ANM_BaseHeader);

	gpANMBuffer = pANMBuffer;

	ANM_Frame*			pFrame  = (ANM_Frame*)	( pANMBuffer +		/// uhhhhhhhh yeaaaaah
									*(DWORD*)	( pANMBuffer +		// this thing looks nasty :)
									*(DWORD*)	( pANMBuffer +		// but its simple
									*(DWORD*)	( gANMListData[inIndex]   ) ) ) );

	//
	// Allocating
	//
	if( pHeader->mnFrames == 1 )
		gppANMFrames = (ANM_Frame**) new DWORD[2];
	else
		gppANMFrames = (ANM_Frame**) new DWORD[pHeader->mnFrames];

	assert( gppANMFrames );


	//
	// Debug Printing
	//
	printf( "Animation Name : \"%s\"\nNumber of Frames : %i\nNumber of Bones : %i\n", pHeader->mAnimName, pHeader->mnFrames, pFrame->mnBones );


	//
	// And Error Checking
	//
	if( pFrame->mnBones != gpModels[0].mpMeshes->mnBones )
	{
		printf( "ERROR : Wrong Number of Bones in ANM : %i - %i\n", pFrame->mnBones, gpModels[0].mpMeshes->mnBones );
		ShutANM( );
		return;
	}


	



	DWORD		frame;
	for( frame=0 ; frame<pHeader->mnFrames ; ++frame )
	{
		gppANMFrames[frame] = (ANM_Frame*)	( pANMBuffer +	 // i luv pointer operations :)
								*(DWORD*)	( pANMBuffer +	
								*(DWORD*)	( pANMBuffer +	
							(	(DWORD*)	( gANMListData[inIndex] ) ) [frame] ) ) );

		// BugFix
		// Misuse this as a flag if it already got loaded 
		//
		if( !gppANMFrames[frame]->mnBones) 
			gppANMFrames[frame]->mpBones = (ANM_Bone*) (pANMBuffer + (DWORD) gppANMFrames[frame]->mpBones);

		gppANMFrames[frame]->mnBones = 0;
	}

	if( pHeader->mnFrames == 1 )
	{
		gppANMFrames[1] = gppANMFrames[0];
		gpAnimTime->set_float_limits( 0.0f, 0.0f );
	}
	else
		gpAnimTime->set_float_limits( 0.0f, pHeader->mnFrames-2 );

	gpAnimTime->enable( );
	gpAnimTime->set_float_val( 0.0f );
	gpAnimPlay->enable( );
}
